<?php

/**
 * @file
 * Contains \Drupal\hookalyzer\Diff\BaseDiff.
 */

namespace Drupal\hookalyzer\Diff;

/**
 * Base class for diffs.
 */
abstract class BaseDiff implements DiffInterface {

  protected $val1;
  protected $val2;
  protected $name;
  protected $changeType = DiffInterface::UNCHANGED;

  /**
   * {@inheritdoc}
   */
  public function __construct($val1, $val2, $name) {
    $this->val1 = $val1;
    $this->val2 = $val2;
    $this->name = $name;
    $this->changeType = $this->val1 === $this->val2 ? self::UNCHANGED : self::VALUE_CHANGE;
  }

  /**
   * {@inheritdoc}
   */
  public function getChangeType() {
    return $this->changeType;
  }

  /**
   * {@inheritdoc}
   */
  public function getName() {
    return $this->name;
  }
}